# -*- coding: utf-8 -*-

import pygame
from   pygame.locals import *

#direction constants
EAST      = 0
NORTHEAST = 1
NORTH     = 2
NORTHWEST = 3
WEST      = 4
SOUTHWEST = 5
SOUTH     = 6
SOUTHEAST = 7

class Entity(pygame.sprite.Sprite):
	def __init__(self):
		self.id = "id1"

class Player(Entity):
	
	def __init__(self, map):
		pygame.sprite.Sprite.__init__(self)

		self.map = map
		self.image = pygame.image.load('./data/entity/ogre/stopped 0000.png').convert_alpha()

		self.rect = self.image.get_rect()
		self.rect.move_ip(50, 50) # posicion inicial

		self.pos_xi = 0 # posicion x
		self.pos_yi = 0 # posicion y

		self.is_running = True

	def update(self):
		" Realiza el movimiento del Player en el Map "
		
		teclas_pulsadas = pygame.key.get_pressed()
		dx = 0
		dy = 0

		if teclas_pulsadas[K_UP]:
			dy = -1

		elif teclas_pulsadas[K_DOWN]:
			dy = 1

		if teclas_pulsadas[K_LEFT]:
			dx = -1

		elif teclas_pulsadas[K_RIGHT]:
			dx = 1

		if not self.map.is_walkable(self.rect.x + dx, self.rect.y):
			dx = 0

		if not self.map.is_walkable(self.rect.x, self.rect.y + dy):
			dy = 0

		self.rect.move_ip(dx, dy)   # cambia la posicion del Player
		self.map.mirar_a(self.rect) # centra la atencion de la camara en el

	def _print(self, screen):
		"Imprime el personaje en la pantalla respetando la cámara."
		x = self.rect.x - self.map.camara_x - self.pos_xi
		y = self.rect.y - self.map.camara_y - self.pos_yi
		screen.blit(self.image, (x, y))
