#!/usr/bin/env python
# -*- coding: utf-8 -*-
# filename: universe.py
#
#    Ceibal Jam Rol.

import pygame

SCREENSIZE = (640,480)
WIDTH  = 640
HEIGHT = 480

class World:
    def __init__(self):
        pass

class Map:
	def __init__(self,path):
		self.level = self._loadlevel(path) # matriz del nivel
		self.tiles = self._loadtiles()     # matriz de bloques del nivel
		self.field = self._loadfield()     # crea el fondo

		self._MapFactory()

	        # coordenada superior izquierda de la cámara.
	        # estas variables intentan alcanzar el valor de las variables
	        # 'destino_camara_x' y 'destino_camara_y'.
	        self.camara_x = 0
	        self.camara_y = 0

	        # indican la posición a la que debe llegar la cámara
	        self.destino_camara_x = 0
	        self.destino_camara_y = 0



	def _loadlevel(self, path):  #def _cargar_grilla(self, ruta):
		datafile = file(path, 'rt')
		level = datafile.readlines()
		datafile.close()
		return level

	def _loadtiles(self):
		tiles = []
		for n in range(5):
			tiles.append(pygame.image.load('./data/textures/%d.png' %n).convert_alpha())
		return tiles

	def _loadfield(self):
		filas    = len(self.level)
		columnas = len(self.level[0]) - 1
		ancho = columnas * 96
		alto  = filas    * 96
		return pygame.Surface((ancho, alto)).convert()



	def _MapFactory(self):
		row_lenght = len(self.level)
		col_lenght = len(self.level[0]) - 1

		self.field.fill((0, 0, 0))

		for row in range(row_lenght):
			for col in range(col_lenght):
				index = int( self.level[row][col] )
				pos_x = (col-row) * (96/3) # col * (100/2)
                                pos_y = (col+row) * (96/3) #row * (116/2)# row * (116-(116/2))
				self.field.blit(self.tiles[index], (pos_x, pos_y+100))


	def imprimir(self, screen):
		origen  = (self.camara_x, self.camara_y, WIDTH, HEIGHT)
		destino = (            0,             0, WIDTH, HEIGHT)
		screen.blit(self.field, destino, origen)
		
		
	def update(self):
		# actualiza la coordenada de la cámara para suavizar el movimiento
		# el factor '10.0' es la 'suavidad' de movimiento, cuando mayor sea
		# este número, mas pequeño será el movimiento de cámara.
		self.camara_x += (self.destino_camara_x - self.camara_x) / 80.0
		self.camara_y += (self.destino_camara_y - self.camara_y) / 80.0


	def mover(self, dx, dy):
		self.destino_camara_x += dx
		self.destino_camara_y += dy
		self._aplicar_limites()

	def mirar_a(self, rect):
		self.destino_camara_x = rect.x - WIDTH / 2
		self.destino_camara_y = rect.y - HEIGHT / 2
		self._aplicar_limites()

	def _aplicar_limites(self):
		if self.destino_camara_x < 0:
			self.destino_camara_x = 0
		if self.destino_camara_y < 0:
			self.destino_camara_y = 0
		
		if self.destino_camara_x + WIDTH > self.field.get_width():
			self.destino_camara_x = self.field.get_width() - WIDTH
		
		if self.destino_camara_y + HEIGHT > self.field.get_height():
			self.destino_camara_y = self.field.get_height() - HEIGHT
		pass

	def is_walkable(self, x, y):
		return True
	
